# Contributing to Xyce&trade;

Thank you for your interest in contributing to Xyce.

## Questions/use support

Do not open a GitHub Issue to ask a use question. Support for Open Source
Community users is available primarily through our [Google
Groups](https://groups.google.com/forum/#!forum/xyce-users) web forum, which is
actively monitored by the Xyce developers. Other ways to contact the Xyce team
can be found on the [Xyce Homepage](https://xyce.sandia.gov/contact-us/).

## Contributing

We welcome bug reports and enhancement requests. Due to internal restrictions,
however, it is difficult for us to accept external contributions at this time
(e.g., via pull requests). Nevertheless, if you would like to discuss the
possibility of a contribution, please [contact us](https://xyce.sandia.gov/contact-us/).

## Bug reports 

If you believe you might have found a bug, your first step should be to see the
most recent Release Notes, which has a table of known defects and possible
workarounds. If you do not see the issue there, and are unsure if you found a
bug, submit a report on the Xyce [Google
Groups](https://groups.google.com/forum/#!forum/xyce-users) web forum.
Participants in the forum could illuminate a mistake in your netlist; or if you
found a known defect, they may be able to supply a workaround. If there are
concerns about using public venues, [other
methods](https://xyce.sandia.gov/contact-us/) for reporting are available.

### Submitting a good bug report

Independent of the method of reporting, there are a few good procedures to
follow when supplying a bug report:
* Use a clear and descriptive title for the issue to identify the problem (if
  using GitHub Issues).
* Supply a working netlist that demonstrates the problem. Ideally, the netlist
  is the minimum required to reproduce the issue.
* Give a good description of the problem, including expected vs. observed
  behavior.
* Report the version of Xyce you are running, as found by running `Xyce -v`
  from the command line.
* Report the operating system you are using.
* Give any other pertinent information, such as:
  - the invocation used to run Xyce
  - whether you are running in serial or parallel
  - the current phase of the moon and the declination of the Earth's magnetic
    field at your location (primarily for difficult-to-reproduce bugs)

### Bug fix contributions

Unfortunately, we cannot directly incorporate bug fix contributions (see the
[Contributing](#contributing) section, above). However, if you do determine a
fix for an some defect, please let us know. You can even supply pseudocode
and/or code snippets, though we are not able to incorporate them, directly.

## Enhancement requests

The priorities of Xyce development are dictated by the needs of projects at
[Sandia National Laboratories](https://www.sandia.gov). However, we do
encourage enhancement requests from the Open Source community, since external
users often identify capabilities that would also be of use at the Labs. Again,
the [Google Groups](https://groups.google.com/forum/#!forum/xyce-users) web
forum is a good venue for requests; but you may also make a request through the
project's GitHub Issues.

